// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// NewPostAccountsParams creates a new PostAccountsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAccountsParams() *PostAccountsParams {
	return &PostAccountsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAccountsParamsWithTimeout creates a new PostAccountsParams object
// with the ability to set a timeout on a request.
func NewPostAccountsParamsWithTimeout(timeout time.Duration) *PostAccountsParams {
	return &PostAccountsParams{
		timeout: timeout,
	}
}

// NewPostAccountsParamsWithContext creates a new PostAccountsParams object
// with the ability to set a context for a request.
func NewPostAccountsParamsWithContext(ctx context.Context) *PostAccountsParams {
	return &PostAccountsParams{
		Context: ctx,
	}
}

// NewPostAccountsParamsWithHTTPClient creates a new PostAccountsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAccountsParamsWithHTTPClient(client *http.Client) *PostAccountsParams {
	return &PostAccountsParams{
		HTTPClient: client,
	}
}

/* PostAccountsParams contains all the parameters to send to the API endpoint
   for the post accounts operation.

   Typically these are written to a http.Request.
*/
type PostAccountsParams struct {

	/* AccountRequest.

	   An array of new Account records
	*/
	AccountRequest *crm_models.AccountRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post accounts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAccountsParams) WithDefaults() *PostAccountsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post accounts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAccountsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post accounts params
func (o *PostAccountsParams) WithTimeout(timeout time.Duration) *PostAccountsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post accounts params
func (o *PostAccountsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post accounts params
func (o *PostAccountsParams) WithContext(ctx context.Context) *PostAccountsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post accounts params
func (o *PostAccountsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post accounts params
func (o *PostAccountsParams) WithHTTPClient(client *http.Client) *PostAccountsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post accounts params
func (o *PostAccountsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountRequest adds the accountRequest to the post accounts params
func (o *PostAccountsParams) WithAccountRequest(accountRequest *crm_models.AccountRequest) *PostAccountsParams {
	o.SetAccountRequest(accountRequest)
	return o
}

// SetAccountRequest adds the accountRequest to the post accounts params
func (o *PostAccountsParams) SetAccountRequest(accountRequest *crm_models.AccountRequest) {
	o.AccountRequest = accountRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostAccountsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AccountRequest != nil {
		if err := r.SetBodyParam(o.AccountRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
