// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package assets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetAssetsParams creates a new GetAssetsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetAssetsParams() *GetAssetsParams {
	return &GetAssetsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetAssetsParamsWithTimeout creates a new GetAssetsParams object
// with the ability to set a timeout on a request.
func NewGetAssetsParamsWithTimeout(timeout time.Duration) *GetAssetsParams {
	return &GetAssetsParams{
		timeout: timeout,
	}
}

// NewGetAssetsParamsWithContext creates a new GetAssetsParams object
// with the ability to set a context for a request.
func NewGetAssetsParamsWithContext(ctx context.Context) *GetAssetsParams {
	return &GetAssetsParams{
		Context: ctx,
	}
}

// NewGetAssetsParamsWithHTTPClient creates a new GetAssetsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetAssetsParamsWithHTTPClient(client *http.Client) *GetAssetsParams {
	return &GetAssetsParams{
		HTTPClient: client,
	}
}

/* GetAssetsParams contains all the parameters to send to the API endpoint
   for the get assets operation.

   Typically these are written to a http.Request.
*/
type GetAssetsParams struct {

	/* AccountID.

	   Taxnexus Record Id of an Account
	*/
	AccountID *string

	/* AssetID.

	   Taxnexus Record Id of an Asset
	*/
	AssetID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get assets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetAssetsParams) WithDefaults() *GetAssetsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get assets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetAssetsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get assets params
func (o *GetAssetsParams) WithTimeout(timeout time.Duration) *GetAssetsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get assets params
func (o *GetAssetsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get assets params
func (o *GetAssetsParams) WithContext(ctx context.Context) *GetAssetsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get assets params
func (o *GetAssetsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get assets params
func (o *GetAssetsParams) WithHTTPClient(client *http.Client) *GetAssetsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get assets params
func (o *GetAssetsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get assets params
func (o *GetAssetsParams) WithAccountID(accountID *string) *GetAssetsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get assets params
func (o *GetAssetsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAssetID adds the assetID to the get assets params
func (o *GetAssetsParams) WithAssetID(assetID *string) *GetAssetsParams {
	o.SetAssetID(assetID)
	return o
}

// SetAssetID adds the assetId to the get assets params
func (o *GetAssetsParams) SetAssetID(assetID *string) {
	o.AssetID = assetID
}

// WithLimit adds the limit to the get assets params
func (o *GetAssetsParams) WithLimit(limit *int64) *GetAssetsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get assets params
func (o *GetAssetsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get assets params
func (o *GetAssetsParams) WithOffset(offset *int64) *GetAssetsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get assets params
func (o *GetAssetsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetAssetsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string

		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {

			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}
	}

	if o.AssetID != nil {

		// query param assetId
		var qrAssetID string

		if o.AssetID != nil {
			qrAssetID = *o.AssetID
		}
		qAssetID := qrAssetID
		if qAssetID != "" {

			if err := r.SetQueryParam("assetId", qAssetID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
