// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package assets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// NewPutAssetParams creates a new PutAssetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutAssetParams() *PutAssetParams {
	return &PutAssetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutAssetParamsWithTimeout creates a new PutAssetParams object
// with the ability to set a timeout on a request.
func NewPutAssetParamsWithTimeout(timeout time.Duration) *PutAssetParams {
	return &PutAssetParams{
		timeout: timeout,
	}
}

// NewPutAssetParamsWithContext creates a new PutAssetParams object
// with the ability to set a context for a request.
func NewPutAssetParamsWithContext(ctx context.Context) *PutAssetParams {
	return &PutAssetParams{
		Context: ctx,
	}
}

// NewPutAssetParamsWithHTTPClient creates a new PutAssetParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutAssetParamsWithHTTPClient(client *http.Client) *PutAssetParams {
	return &PutAssetParams{
		HTTPClient: client,
	}
}

/* PutAssetParams contains all the parameters to send to the API endpoint
   for the put asset operation.

   Typically these are written to a http.Request.
*/
type PutAssetParams struct {

	/* AssetRequest.

	   An array of new Asset records
	*/
	AssetRequest *crm_models.AssetRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put asset params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutAssetParams) WithDefaults() *PutAssetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put asset params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutAssetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put asset params
func (o *PutAssetParams) WithTimeout(timeout time.Duration) *PutAssetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put asset params
func (o *PutAssetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put asset params
func (o *PutAssetParams) WithContext(ctx context.Context) *PutAssetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put asset params
func (o *PutAssetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put asset params
func (o *PutAssetParams) WithHTTPClient(client *http.Client) *PutAssetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put asset params
func (o *PutAssetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAssetRequest adds the assetRequest to the put asset params
func (o *PutAssetParams) WithAssetRequest(assetRequest *crm_models.AssetRequest) *PutAssetParams {
	o.SetAssetRequest(assetRequest)
	return o
}

// SetAssetRequest adds the assetRequest to the put asset params
func (o *PutAssetParams) SetAssetRequest(assetRequest *crm_models.AssetRequest) {
	o.AssetRequest = assetRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutAssetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AssetRequest != nil {
		if err := r.SetBodyParam(o.AssetRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
