// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// PostContractsReader is a Reader for the PostContracts structure.
type PostContractsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostContractsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostContractsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostContractsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostContractsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostContractsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostContractsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostContractsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostContractsOK creates a PostContractsOK with default headers values
func NewPostContractsOK() *PostContractsOK {
	return &PostContractsOK{}
}

/* PostContractsOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Contract objects
*/
type PostContractsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.ContractResponse
}

func (o *PostContractsOK) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsOK  %+v", 200, o.Payload)
}
func (o *PostContractsOK) GetPayload() *crm_models.ContractResponse {
	return o.Payload
}

func (o *PostContractsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.ContractResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsUnauthorized creates a PostContractsUnauthorized with default headers values
func NewPostContractsUnauthorized() *PostContractsUnauthorized {
	return &PostContractsUnauthorized{}
}

/* PostContractsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostContractsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostContractsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnauthorized  %+v", 401, o.Payload)
}
func (o *PostContractsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsForbidden creates a PostContractsForbidden with default headers values
func NewPostContractsForbidden() *PostContractsForbidden {
	return &PostContractsForbidden{}
}

/* PostContractsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostContractsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostContractsForbidden) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsForbidden  %+v", 403, o.Payload)
}
func (o *PostContractsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsNotFound creates a PostContractsNotFound with default headers values
func NewPostContractsNotFound() *PostContractsNotFound {
	return &PostContractsNotFound{}
}

/* PostContractsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostContractsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostContractsNotFound) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsNotFound  %+v", 404, o.Payload)
}
func (o *PostContractsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsUnprocessableEntity creates a PostContractsUnprocessableEntity with default headers values
func NewPostContractsUnprocessableEntity() *PostContractsUnprocessableEntity {
	return &PostContractsUnprocessableEntity{}
}

/* PostContractsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostContractsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostContractsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostContractsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsInternalServerError creates a PostContractsInternalServerError with default headers values
func NewPostContractsInternalServerError() *PostContractsInternalServerError {
	return &PostContractsInternalServerError{}
}

/* PostContractsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostContractsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostContractsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsInternalServerError  %+v", 500, o.Payload)
}
func (o *PostContractsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
