// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/research/research_models"
)

// NewPutAccountParams creates a new PutAccountParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutAccountParams() *PutAccountParams {
	return &PutAccountParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutAccountParamsWithTimeout creates a new PutAccountParams object
// with the ability to set a timeout on a request.
func NewPutAccountParamsWithTimeout(timeout time.Duration) *PutAccountParams {
	return &PutAccountParams{
		timeout: timeout,
	}
}

// NewPutAccountParamsWithContext creates a new PutAccountParams object
// with the ability to set a context for a request.
func NewPutAccountParamsWithContext(ctx context.Context) *PutAccountParams {
	return &PutAccountParams{
		Context: ctx,
	}
}

// NewPutAccountParamsWithHTTPClient creates a new PutAccountParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutAccountParamsWithHTTPClient(client *http.Client) *PutAccountParams {
	return &PutAccountParams{
		HTTPClient: client,
	}
}

/* PutAccountParams contains all the parameters to send to the API endpoint
   for the put account operation.

   Typically these are written to a http.Request.
*/
type PutAccountParams struct {

	/* AccountRequest.

	   A request with an array of Account Objects
	*/
	AccountRequest *research_models.AccountRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutAccountParams) WithDefaults() *PutAccountParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutAccountParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put account params
func (o *PutAccountParams) WithTimeout(timeout time.Duration) *PutAccountParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put account params
func (o *PutAccountParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put account params
func (o *PutAccountParams) WithContext(ctx context.Context) *PutAccountParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put account params
func (o *PutAccountParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put account params
func (o *PutAccountParams) WithHTTPClient(client *http.Client) *PutAccountParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put account params
func (o *PutAccountParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountRequest adds the accountRequest to the put account params
func (o *PutAccountParams) WithAccountRequest(accountRequest *research_models.AccountRequest) *PutAccountParams {
	o.SetAccountRequest(accountRequest)
	return o
}

// SetAccountRequest adds the accountRequest to the put account params
func (o *PutAccountParams) SetAccountRequest(accountRequest *research_models.AccountRequest) {
	o.AccountRequest = accountRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutAccountParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AccountRequest != nil {
		if err := r.SetBodyParam(o.AccountRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
