// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetContactsParams creates a new GetContactsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetContactsParams() *GetContactsParams {
	return &GetContactsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetContactsParamsWithTimeout creates a new GetContactsParams object
// with the ability to set a timeout on a request.
func NewGetContactsParamsWithTimeout(timeout time.Duration) *GetContactsParams {
	return &GetContactsParams{
		timeout: timeout,
	}
}

// NewGetContactsParamsWithContext creates a new GetContactsParams object
// with the ability to set a context for a request.
func NewGetContactsParamsWithContext(ctx context.Context) *GetContactsParams {
	return &GetContactsParams{
		Context: ctx,
	}
}

// NewGetContactsParamsWithHTTPClient creates a new GetContactsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetContactsParamsWithHTTPClient(client *http.Client) *GetContactsParams {
	return &GetContactsParams{
		HTTPClient: client,
	}
}

/* GetContactsParams contains all the parameters to send to the API endpoint
   for the get contacts operation.

   Typically these are written to a http.Request.
*/
type GetContactsParams struct {

	/* AccountID.

	   Taxnexus Record Id of an Account
	*/
	AccountID *string

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* ContactID.

	   Taxnexus Record Id of a Contact
	*/
	ContactID *string

	/* Email.

	   Email address used for identity lookup
	*/
	Email *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Name.

	   The Name of this Object
	*/
	Name *string

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetContactsParams) WithDefaults() *GetContactsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetContactsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get contacts params
func (o *GetContactsParams) WithTimeout(timeout time.Duration) *GetContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get contacts params
func (o *GetContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get contacts params
func (o *GetContactsParams) WithContext(ctx context.Context) *GetContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get contacts params
func (o *GetContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get contacts params
func (o *GetContactsParams) WithHTTPClient(client *http.Client) *GetContactsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get contacts params
func (o *GetContactsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get contacts params
func (o *GetContactsParams) WithAccountID(accountID *string) *GetContactsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get contacts params
func (o *GetContactsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get contacts params
func (o *GetContactsParams) WithActive(active *bool) *GetContactsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get contacts params
func (o *GetContactsParams) SetActive(active *bool) {
	o.Active = active
}

// WithContactID adds the contactID to the get contacts params
func (o *GetContactsParams) WithContactID(contactID *string) *GetContactsParams {
	o.SetContactID(contactID)
	return o
}

// SetContactID adds the contactId to the get contacts params
func (o *GetContactsParams) SetContactID(contactID *string) {
	o.ContactID = contactID
}

// WithEmail adds the email to the get contacts params
func (o *GetContactsParams) WithEmail(email *string) *GetContactsParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get contacts params
func (o *GetContactsParams) SetEmail(email *string) {
	o.Email = email
}

// WithLimit adds the limit to the get contacts params
func (o *GetContactsParams) WithLimit(limit *int64) *GetContactsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get contacts params
func (o *GetContactsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the get contacts params
func (o *GetContactsParams) WithName(name *string) *GetContactsParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get contacts params
func (o *GetContactsParams) SetName(name *string) {
	o.Name = name
}

// WithOffset adds the offset to the get contacts params
func (o *GetContactsParams) WithOffset(offset *int64) *GetContactsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get contacts params
func (o *GetContactsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string

		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {

			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}
	}

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.ContactID != nil {

		// query param contactId
		var qrContactID string

		if o.ContactID != nil {
			qrContactID = *o.ContactID
		}
		qContactID := qrContactID
		if qContactID != "" {

			if err := r.SetQueryParam("contactId", qContactID); err != nil {
				return err
			}
		}
	}

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
