// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// NewPostContractsParams creates a new PostContractsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostContractsParams() *PostContractsParams {
	return &PostContractsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostContractsParamsWithTimeout creates a new PostContractsParams object
// with the ability to set a timeout on a request.
func NewPostContractsParamsWithTimeout(timeout time.Duration) *PostContractsParams {
	return &PostContractsParams{
		timeout: timeout,
	}
}

// NewPostContractsParamsWithContext creates a new PostContractsParams object
// with the ability to set a context for a request.
func NewPostContractsParamsWithContext(ctx context.Context) *PostContractsParams {
	return &PostContractsParams{
		Context: ctx,
	}
}

// NewPostContractsParamsWithHTTPClient creates a new PostContractsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostContractsParamsWithHTTPClient(client *http.Client) *PostContractsParams {
	return &PostContractsParams{
		HTTPClient: client,
	}
}

/* PostContractsParams contains all the parameters to send to the API endpoint
   for the post contracts operation.

   Typically these are written to a http.Request.
*/
type PostContractsParams struct {

	/* ContractsRequest.

	   An array of new Contract records
	*/
	ContractsRequest *sfgate_models.ContractRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post contracts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostContractsParams) WithDefaults() *PostContractsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post contracts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostContractsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post contracts params
func (o *PostContractsParams) WithTimeout(timeout time.Duration) *PostContractsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post contracts params
func (o *PostContractsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post contracts params
func (o *PostContractsParams) WithContext(ctx context.Context) *PostContractsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post contracts params
func (o *PostContractsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post contracts params
func (o *PostContractsParams) WithHTTPClient(client *http.Client) *PostContractsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post contracts params
func (o *PostContractsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContractsRequest adds the contractsRequest to the post contracts params
func (o *PostContractsParams) WithContractsRequest(contractsRequest *sfgate_models.ContractRequest) *PostContractsParams {
	o.SetContractsRequest(contractsRequest)
	return o
}

// SetContractsRequest adds the contractsRequest to the post contracts params
func (o *PostContractsParams) SetContractsRequest(contractsRequest *sfgate_models.ContractRequest) {
	o.ContractsRequest = contractsRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostContractsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ContractsRequest != nil {
		if err := r.SetBodyParam(o.ContractsRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
